#include	<stdio.h>
#include	<poll.h>
#include	<time.h>
#include	<sys/time.h>
#include	<ctype.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<string.h>
#include	<errno.h>
#include	<signal.h>
#include	<sys/param.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<netdb.h>

#define	PARAM_PATH	"./udptest.ini"
#define	MAX_DATA_SIZE	1400

struct	{
	char	*TargetIp;
	char	*Port;
	int	IntervalUsec;
	unsigned long	SendNo;
	int	DataSize;
	int	RecvTimeoutSec;
	char	*RecvCsvOut;
}Param={"undefine","undefine",0,1,1400,2,NULL};

int ReadParam(char *fname)
{
FILE	*fp;
char	buf[1024],*ptr,*ptr2;

	if((fp=fopen(fname,"r"))==NULL){
		fprintf(stderr,"cannot read %s\n",fname);
		return(-1);
	}

	while(1){
		fgets(buf,sizeof(buf),fp);
		if(feof(fp)){
			break;
		}
		if(buf[0]=='#'){
			continue;
		}
		if((ptr=strtok(buf,"="))!=NULL){
			if((ptr2=strtok(NULL,"\r\n"))!=NULL){
				if(strcmp(ptr,"TargetIp")==0){
					Param.TargetIp=strdup(ptr2);
				}
				else if(strcmp(ptr,"Port")==0){
					Param.Port=strdup(ptr2);
				}
				else if(strcmp(ptr,"IntervalUsec")==0){
					Param.IntervalUsec=atoi(ptr2);
				}
				else if(strcmp(ptr,"SendNo")==0){
					Param.SendNo=atol(ptr2);
				}
				else if(strcmp(ptr,"DataSize")==0){
					Param.DataSize=atoi(ptr2);
				}
				else if(strcmp(ptr,"RecvTimeoutSec")==0){
					Param.RecvTimeoutSec=atoi(ptr2);
				}
				else if(strcmp(ptr,"RecvCsvOut")==0){
					Param.RecvCsvOut=strdup(ptr2);
				}
			}
		}
	}

	fclose(fp);

	if(Param.IntervalUsec<0){
		fprintf(stderr,"IntervalUsec(%d) < 0\n",Param.IntervalUsec);
		return(-1);
	}
	if(Param.SendNo<1){
		fprintf(stderr,"SendNo(%lu) < 1\n",Param.SendNo);
		return(-1);
	}
	if(Param.DataSize<1){
		fprintf(stderr,"DataSize(%d) < 1)\n",Param.DataSize);
		return(-1);
	}
	if(Param.DataSize<4){
		fprintf(stderr,"DataSize(%d) < 4\n",Param.DataSize);
		return(-1);
	}
	if(Param.DataSize>1400){
		fprintf(stderr,"DataSize(%d) > 1400\n",Param.DataSize);
		return(-1);
	}
	if(Param.RecvTimeoutSec<0){
		fprintf(stderr,"RecvTimeoutSec(%d) < 0\n",Param.RecvTimeoutSec);
		return(-1);
	}

	fprintf(stderr,"------------------------\n");
	fprintf(stderr,"TargetIp=%s\n",Param.TargetIp);
	fprintf(stderr,"Port=%s\n",Param.Port);
	fprintf(stderr,"IntervalUsec=%d\n",Param.IntervalUsec);
	fprintf(stderr,"SendNo=%lu\n",Param.SendNo);
	fprintf(stderr,"DataSize=%d\n",Param.DataSize);
	fprintf(stderr,"RecvTimeoutSec=%d\n",Param.RecvTimeoutSec);
	if(Param.RecvCsvOut==NULL){
		fprintf(stderr,"RecvCsvOut=(null)\n");
	}
	else{
		fprintf(stderr,"RecvCsvOut=%s\n",Param.RecvCsvOut);
	}
	fprintf(stderr,"------------------------\n");

	return(0);
}

int GetAddress(char *hostnm,char *portnm,struct sockaddr_in *saddr,int *saddr_len)
{
struct in_addr	addr;
struct hostent	*host;
struct sockaddr_in	server;
struct servent	*se;
int	 portno;

	memset((char *)&server,0,sizeof(server));
	server.sin_family=AF_INET;

	if((addr.s_addr=inet_addr(hostnm))==-1){
		host=gethostbyname(hostnm);
		if(host==NULL){
			perror("gethostbyname");
			return(-1);
		}
		memcpy(&addr,(struct in_addr *)*host->h_addr_list,sizeof(struct in_addr));
	}
	//fprintf(stderr,"addr=%s\n",inet_ntoa(addr));
	server.sin_addr=addr;

	if(isdigit(portnm[0])){
		if((portno=atoi(portnm))<=0){
			fprintf(stderr,"bad port no\n");
			return(-1);
		}
		server.sin_port=htons(portno);
	}
	else{
		if((se=getservbyname(portnm,"udp"))==NULL){
			fprintf(stderr,"getservbyname():error\n");
			return(-1);
		}
		else{
			server.sin_port=se->s_port;
		}
	}
	//fprintf(stderr,"port=%d\n",ntohs(server.sin_port));

	memcpy(saddr,&server,sizeof(struct sockaddr_in));
	*saddr_len=sizeof(struct sockaddr_in);

	return(0);
}

int UDPServerSocket(char *portnm)
{
int	 soc,portno,opt;
struct servent	*se;
struct sockaddr_in	my;

	memset((char *)&my,0,sizeof(my));
	my.sin_family=AF_INET;
	my.sin_addr.s_addr=htonl(INADDR_ANY);

	if(isdigit(portnm[0])){
		if((portno=atoi(portnm))<=0){
			fprintf(stderr,"bad port no\n");
			return(-1);
		}
		my.sin_port=htons(portno);
	}
	else{
		if((se=getservbyname(portnm,"udp"))==NULL){
			fprintf(stderr,"getservbyname():error\n");
			return(-1);
		}
		else{
			my.sin_port=se->s_port;
		}
	}
	//fprintf(stderr,"port=%d\n",ntohs(my.sin_port));

	if((soc=socket(AF_INET,SOCK_DGRAM,0))<0){
		perror("socket");
		return(-1);
	}

	opt=1;
	if(setsockopt(soc,SOL_SOCKET,SO_REUSEADDR,(char *)&opt,sizeof(int))!=0){
		perror("setsockopt");
		return(-1);
	}

	if(bind(soc,(struct sockaddr *)&my,sizeof(my))==-1){
		perror("bind");
		return(-1);
	}

	return(soc);
}

int DoSend()
{
int	i,soc,len;
long	data;
char	buf[MAX_DATA_SIZE];
struct timespec	req;
struct sockaddr_in	to;
int	tolen;
struct timeval	starttime,endtime,laptime;
double	lap,throughput;
unsigned long	count;

	if(GetAddress(Param.TargetIp,Param.Port,&to,&tolen)==-1){
		fprintf(stderr,"GetAddress(%s,%s):error\n",Param.TargetIp,Param.Port);
		return(-1);
	}

	if((soc=socket(AF_INET,SOCK_DGRAM,0))<0){
		perror("socket");
		return(-1);
	}

	req.tv_sec=0;
	req.tv_nsec=Param.IntervalUsec*1000;
	count=0;
	gettimeofday(&starttime,NULL);
	for(i=0;i<Param.SendNo;i++){
		data=htonl((long)i);
		memcpy(buf,&data,sizeof(long));
		if((len=sendto(soc,buf,Param.DataSize,0,(struct sockaddr *)&to,tolen))<0){
			perror("sendto");
			break;
		}
		count++;
		if(Param.IntervalUsec!=0&&i!=Param.SendNo-1){
			nanosleep(&req,NULL);
		}
	}
	gettimeofday(&endtime,NULL);

	close(soc);

	fprintf(stderr,"------------------------\n");

        laptime.tv_usec=endtime.tv_usec-starttime.tv_usec;
        laptime.tv_sec=endtime.tv_sec-starttime.tv_sec;
        if(laptime.tv_usec<0){
                laptime.tv_usec+=1000000;
                laptime.tv_sec--;
        }
        fprintf(stderr,"total:%lu packets in %d.%06d\n",count,(int)laptime.tv_sec,(int)laptime.tv_usec);
        lap=(double)laptime.tv_sec+(double)laptime.tv_usec/1000000.0;
        throughput=(double)(sizeof(buf)*count)/lap;
        if(throughput>1000000.0){
                fprintf(stderr,"throughput:%gM byte/sec (%gM bps)\n",throughput/1000000.0,throughput*8.0/1000000.0);
        }
        else if(throughput>1000.0){
                fprintf(stderr,"throughput:%gK byte/sec (%gK bps)\n",throughput/1000.0,throughput*8.0/1000.0);
        }
        else{
                fprintf(stderr,"throughput:%g byte/sec (%g bps)\n",throughput,throughput*8.0);
        }

	fprintf(stderr,"------------------------\n");

	return(0);
}

int DoRecv()
{
int	soc;
char	buf[MAX_DATA_SIZE];
long	data,beforedata;
socklen_t	fromlen;
struct sockaddr_in	from;
int	first,end,len;
unsigned long	count,shufflecount;
struct timeval	starttime,endtime,laptime;
double	lap,throughput;
struct pollfd	targets[1];
int	nready;
FILE	*fp=NULL;

	soc=UDPServerSocket(Param.Port);
	if(soc==-1){
		fprintf(stderr,"UDPServerSocket(%s):error\n",Param.Port);
		return(-1);
	}

	if(Param.RecvCsvOut!=NULL){
		if((fp=fopen(Param.RecvCsvOut,"w"))==NULL){
			fprintf(stderr,"cannot write %s\n",Param.RecvCsvOut);
			close(soc);
			return(-1);
		}
	}

	targets[0].fd=soc;
	targets[0].events=POLLIN|POLLERR;

	first=1;
	end=0;
	count=0;
	shufflecount=0;
	beforedata=0;
	do{
		switch((nready=poll(targets,1,Param.RecvTimeoutSec*1000))){
			case	-1:
				if(errno!=EINTR){
					perror("poll");
					end=1;
					break;
				}
				break;
			case	0:
				if(!first){
					fprintf(stderr,"timeout:end\n");
					end=1;
				}
				break;
			default:
				if(targets[0].revents&(POLLIN|POLLERR)){
					fromlen=sizeof(from);
					if((len=recvfrom(soc,buf,sizeof(buf),0,(struct sockaddr *)&from,&fromlen))<0){
						perror("recvfrom");
					}
					memcpy(&data,buf,sizeof(long));
					data=ntohl(data);
					count++;
					if(first){
						fprintf(stderr,"first packet received\n");
						gettimeofday(&starttime,NULL);
						first=0;
					}
					else{
						gettimeofday(&endtime,NULL);
						if(Param.RecvCsvOut!=NULL){
							laptime.tv_usec=endtime.tv_usec-starttime.tv_usec;
							laptime.tv_sec=endtime.tv_sec-starttime.tv_sec;
							if(laptime.tv_usec<0){
								laptime.tv_usec+=1000000;
								laptime.tv_sec--;
							}
							fprintf(fp,"%ld,%d.%06d\n",data,(int)laptime.tv_sec,(int)laptime.tv_usec);
						}
					}
					if(data<beforedata){
						shufflecount++;
					}
					beforedata=data;
				}
				break;
		}
	}while(!end);

	if(Param.RecvCsvOut!=NULL){
		fclose(fp);
	}

	fprintf(stderr,"------------------------\n");

	laptime.tv_usec=endtime.tv_usec-starttime.tv_usec;
	laptime.tv_sec=endtime.tv_sec-starttime.tv_sec;
	if(laptime.tv_usec<0){
		laptime.tv_usec+=1000000;
		laptime.tv_sec--;
	}
	fprintf(stderr,"total:%lu packets in %d.%06d\n",count,(int)laptime.tv_sec,(int)laptime.tv_usec);
	lap=(double)laptime.tv_sec+(double)laptime.tv_usec/1000000.0;
	throughput=(double)(sizeof(buf)*count)/lap;
	if(throughput>1000000.0){
		fprintf(stderr,"throughput:%gM byte/sec (%gM bps)\n",throughput/1000000.0,throughput*8.0/1000000.0);
	}
	else if(throughput>1000.0){
		fprintf(stderr,"throughput:%gK byte/sec (%gK bps)\n",throughput/1000.0,throughput*8.0/1000.0);
	}
	else{
		fprintf(stderr,"throughput:%g byte/sec (%g bps)\n",throughput,throughput*8.0);
	}
	fprintf(stderr,"%lu packets shuffled\n",shufflecount);

	fprintf(stderr,"------------------------\n");

	return(0);
}

int main(int argc,char *argv[])
{

	if(argc<=1){
		fprintf(stderr,"udptest\n");
		fprintf(stderr,"[Send] -s [param-path]\n");
		fprintf(stderr,"[Recv] -r [param-path]\n");
		return(-1);
	}

	if(argc>=3){
		if(ReadParam(argv[2])==-1){
			return(-1);
		}
	}
	else{
		if(ReadParam(PARAM_PATH)==-1){
			return(-1);
		}
	}

	if(strcmp(argv[1],"-s")==0){
		DoSend();
	}
	else if(strcmp(argv[1],"-r")==0){
		DoRecv();
	}
	else{
		fprintf(stderr,"udptest\n");
		fprintf(stderr,"[Send] -s [param-path]\n");
		fprintf(stderr,"[Recv] -r [param-path]\n");
		return(-1);
	}

	return(0);
}
